<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:h="http://java.sun.com/jsf/html" xmlns:f="http://java.sun.com/jsf/core"
	xmlns:ship="http://xmlns.jcp.org/jsf/composite/ship" xmlns:p="http://primefaces.org/ui" xmlns:c="http://java.sun.com/jsp/jstl/core" >
<h:head></h:head>
<h:body>
	<ui:composition template="/pages/primodaltemplate.xhtml">
		<ui:define name="title">
			<h:outputText value="#{facesContext.translate('title.item.edit', statisticModel.functionBean.name)}" />
		</ui:define>
		<ui:define name="body">
			<h:outputText value="#{facesContext.translate('label.statistic.edit.description')}" />
			<br />
			<p:panelGrid columns="2">
				<ship:taggedLabel value="#{facesContext.translate('label.statistic.functionname')}" help="#{facesContext.translate('label.statistic.help.functionname')}" />
				<p:inputText id="name" required="true" value="#{statisticModel.functionBean.name}" validatorMessage="#{facesContext.translate('validation.statistic.functionname')}">
					<f:validateRegex pattern="^[a-zA-Z][a-zA-Z0-9._]{0,63}$" />
				</p:inputText>
				<h:outputText value="#{facesContext.translate('label.vignette')}" />
				<p:inputText value="#{statisticModel.functionBean.vignette}" />
				<ship:taggedLabel value="#{facesContext.translate('label.statistic.functionbefore')}" help="#{facesContext.translate('label.statistic.help.functionbefore')}" />
				<p:inputTextarea id="before" value="#{statisticModel.functionBean.before}" cols="80" rows="8" />
				<ship:taggedLabel value="#{facesContext.translate('label.statistic.functionbody')}" help="#{facesContext.translate('label.statistic.help.functionbody')}" />
				<p:inputTextarea id="body" value="#{statisticModel.functionBean.body}" cols="80" rows="8" />
				<ship:taggedLabel value="#{facesContext.translate('label.statistic.functionafter')}" help="#{facesContext.translate('label.statistic.help.functionafter')}" />
				<p:inputTextarea id="after" value="#{statisticModel.functionBean.after}" cols="80" rows="8" />
				<ship:taggedLabel value="#{facesContext.translate('label.statistic.functiontest')}" help="#{facesContext.translate('label.statistic.help.functiontest')}" />
				<p:inputTextarea id="test" value="#{statisticModel.functionBean.test}" cols="80" rows="8" />
				<ship:taggedLabel value="#{facesContext.translate('label.statistic.summary')}" help="#{facesContext.translate('label.statistic.help.functionsummary')}" />
				<p:inputText id="summary" value="#{statisticModel.functionBean.summary}" />
				<ship:taggedLabel value="#{facesContext.translate('label.statistic.description')}" help="#{facesContext.translate('label.statistic.help.functiondescription')}" />
				<p:inputTextarea id="descr" value="#{statisticModel.functionBean.description}" cols="80" rows="8" />
				<ship:taggedLabel value="#{facesContext.translate('label.statistic.category')}" help="#{facesContext.translate('label.statistic.help.functioncategory')}" />
				<h:panelGroup id="category">
					<ui:repeat value="#{statisticModel.functionBean.category}" var="cat" varStatus="status">
						<p:commandButton id="btn_cat_#{status.index}" action="#{statisticModel.removeCategoryFromBean(cat)}" value="#{cat.name}" styleClass="squarebadge" title="#{cat.description}"
							icon="fa fa-times-circle" ajax="true" update="form" />
					</ui:repeat>
					<p:menuButton value="add" icon="fa fa-plus-square">
						<c:forEach items="#{statisticModel.unchoosedCategoryOfBean}" var="c" varStatus="status">
							<p:menuitem id="btn_ctb_#{status.index}" action="#{statisticModel.addCategoryToBean(c)}" value="#{c.name}" title="#{c.description}" ajax="true" update="form" />
						</c:forEach>
					</p:menuButton>
				</h:panelGroup>
				<h:outputText value="" />
				<p:selectOneMenu id="varlist" value="#{statisticModel.functionBean.varlist}" filter="true">
					<f:selectItem itemValue="false" itemLabel="#{facesContext.translate('label.statistic.varlist.false')}" />
					<f:selectItem itemValue="true" itemLabel="#{facesContext.translate('label.statistic.varlist.true')}" />
					<f:selectItem itemValue="empty" itemLabel="#{facesContext.translate('label.statistic.varlist.null')}" />
				</p:selectOneMenu>
				<h:outputText value="#{facesContext.translate('label.statistic.varname')}" />
				<p:inputText required="true" id="varname" value="#{statisticModel.functionBean.varname}" />
				<h:outputText value="#{facesContext.translate('label.statistic.dataframe')}" />
				<p:inputText id="dataframe" value="#{statisticModel.functionBean.dataframe}" />
				<h:outputText value="#{facesContext.translate('label.statistic.vardef')}" />
				<p:inputText id="vardef" value="#{statisticModel.functionBean.vardef}" />
				<h:outputText value="#{facesContext.translate('label.statistic.datasource')}" />
				<p:selectOneMenu id="datasource" value="#{statisticModel.functionBean.datasource}" filter="true">
					<f:selectItem itemLabel="#{facesContext.translate('enum.datasource.raw')}" itemValue="raw" />
					<f:selectItem itemLabel="#{facesContext.translate('enum.datasource.nomissing')}" itemValue="nomissing" />
					<f:selectItem itemLabel="#{facesContext.translate('enum.datasource.transcoded')}" itemValue="transcoded" />
				</p:selectOneMenu>
				<h:outputText value="" />
				<p:selectBooleanCheckbox id="intervals" value="#{statisticModel.functionBean.useIntervals}" itemLabel="#{facesContext.translate('label.statistic.useintervals')}" />
				<!-- INPUT -->
				<ship:taggedLabel value="#{facesContext.translate('label.statistic.input')}" help="#{facesContext.translate('label.statistic.help.functioninput')}" />
				<p:panelGrid id="inputTablePanel" columns="1">
					<p:staticMessage detail="#{statisticModel.ajaxInputMessage}" severity="danger" rendered="#{statisticModel.hasAjaxInputMessage}" />
					<p:dataTable id="inputTable" value="#{statisticModel.functionBean.input}" var="i">
						<p:column headerText="#{facesContext.translate('label.name')}">
							<h:outputText value="#{i.name}" />
							<f:facet name="footer">
								<p:inputText id="name" value="#{statisticModel.functionInputBean.name}" />
							</f:facet>
						</p:column>
						<p:column headerText="#{facesContext.translate('label.statistic.inputusage')}">
							<p:selectOneMenu id="type" value="#{i.fkType}" converter="inputtype" converterMessage="#{facesContext.translate('error.converter', 'label.statistic.inputusage')}" filter="true" editable="false">
								<f:selectItems value="#{statisticModel.inputtypes}" var="t" itemValue="#{t}" itemLabel="#{t.translation}" />
							</p:selectOneMenu>
							<f:facet name="footer">
								<p:selectOneMenu id="fktype" value="#{statisticModel.functionInputBean.fkType}" converter="inputtype" converterMessage="#{facesContext.translate('error.converter', 'label.statistic.inputusage')}" filter="true">
									<f:selectItems value="#{statisticModel.inputtypes}" var="t" itemValue="#{t}" itemLabel="#{t.translation}" />
								</p:selectOneMenu>
							</f:facet>
						</p:column>
						<p:column headerText="#{facesContext.translate('label.statistic.inputstandard')}">
							<ship:outputJson value="#{i.standard}" />
							<f:facet name="footer">
								<ship:inputJson id="std" value="#{statisticModel.functionInputBean.standard}" />
							</f:facet>
						</p:column>
						<p:column headerText="#{facesContext.translate('label.description')}">
							<h:outputText value="#{i.description}" />
							<f:facet name="footer">
								<p:inputText id="ndescr" value="#{statisticModel.functionInputBean.description}" />
							</f:facet>
						</p:column>
						<p:column>
							<ship:removeButton action="#{statisticController.doAjaxRemoveFunctionInput(i)}" value="" tooltip="#{facesContext.translate('button.remove')}" isLink="false"
								title="#{facesContext.translate('title.delete.approve')}" approveButtonLabel="#{facesContext.translate('button.yes')}" cancelButtonLabel="#{facesContext.translate('button.no')}">
								<h:outputText value="#{facesContext.translate('confirmation.delete', i.name)}" />
							</ship:removeButton>
							<f:facet name="footer">
								<p:commandButton id="btn_editfi" action="#{statisticController.doAjaxAddFunctionInput}" icon="fa fa-plus" value="" title="#{facesContext.translate('button.add')}"
									style="height: 36px" ajax="true" update="form:inputTablePanel" styleClass="iconbutton" />
							</f:facet>
						</p:column>
					</p:dataTable>
				</p:panelGrid>
				<!-- OUTPUT -->
				<ship:taggedLabel value="#{facesContext.translate('label.statistic.output')}" help="#{facesContext.translate('label.statistic.help.functionoutput')}" />
				<p:panelGrid id="outputTablePanel" columns="1">
					<p:staticMessage detail="#{statisticModel.ajaxOutputMessage}" severity="danger" rendered="#{statisticModel.hasAjaxOutputMessage}" />
					<p:dataTable id="outputTable" value="#{statisticModel.functionBean.output}" var="o">
						<p:column headerText="#{facesContext.translate('label.statistic.outputname')}">
							<h:outputText value="#{o.name}" />
							<f:facet name="footer">
								<p:inputText id="name" value="#{statisticModel.functionOutputBean.name}" />
							</f:facet>
						</p:column>
						<p:column headerText="#{facesContext.translate('label.statistic.outputusage')}">
							<p:selectOneMenu id="usage" value="#{o.usage}" filter="true" editable="false">
								<f:selectItems value="#{statisticModel.outputtypes}" var="o2" itemValue="#{o2.pk}" itemLabel="#{o2.name} (#{o2.description})" />
							</p:selectOneMenu>
							<f:facet name="footer">
								<p:selectOneMenu id="usageadd" value="#{statisticModel.functionOutputBean.usage}" filter="true">
									<f:selectItems value="#{statisticModel.outputtypes}" var="o2" itemValue="#{o2.pk}" itemLabel="#{o2.name} (#{o2.description})" />
								</p:selectOneMenu>
							</f:facet>
						</p:column>
						<p:column label="#{facesContext.translate('label.statistic.description')}">
							<h:outputText value="#{o.description}" />
							<f:facet name="footer">
								<p:inputText id="descradd" value="#{statisticModel.functionOutputBean.description}" />
							</f:facet>
						</p:column>
						<p:column>
							<ship:removeButton action="#{statisticController.doAjaxRemoveFunctionOutput(o.name)}" value="" tooltip="#{facesContext.translate('button.remove')}" isLink="false"
								title="#{facesContext.translate('title.delete.approve')}" approveButtonLabel="#{facesContext.translate('button.yes')}" cancelButtonLabel="#{facesContext.translate('button.no')}">
								<h:outputText value="#{facesContext.translate('confirmation.delete', o.name)}" />
							</ship:removeButton>
							<f:facet name="footer">
								<p:commandButton id="btn_addfo" action="#{statisticController.doAjaxAddFunctionOutput}" value="" title="#{facesContext.translate('button.add')}" icon="fa fa-plus"
									style="height: 36px" ajax="true" update="form:outputTablePanel" />
							</f:facet>
						</p:column>
					</p:dataTable>
				</p:panelGrid>
				<!-- SCALE -->
				<ship:taggedLabel value="#{facesContext.translate('label.statistic.scaleniveau')}" help="#{facesContext.translate('label.statistic.help.scaleniveau')}" />
				<ui:repeat value="#{statisticModel.functionBean.scales}" var="scale" varStatus="status">
					<p:selectBooleanCheckbox id="scale_#{status.index}" value="#{scale.checked}" itemLabel="#{scale.name}" />
				</ui:repeat>
				<ship:taggedLabel value="#{facesContext.translate('label.statistic.reference')}" help="#{facesContext.translate('label.statistic.help.functionreference')}" />
				<h:dataTable id="referenceTable" value="#{statisticModel.functionBean.reference}" var="r" headerClass="tableheader" columnClasses="top">
					<h:column>
						<f:facet name="header">
							<h:outputText value="#{facesContext.translate('label.statistic.functionname')}" />
						</f:facet>
						<h:outputText value="#{r.name}" />
						<f:facet name="footer">
							<p:selectOneMenu id="reference" value="#{statisticModel.reference}" filter="true">
								<f:selectItems value="#{statisticModel.references}" var="r" itemLabel="#{r.name}" itemValue="#{r.functionId}" />
							</p:selectOneMenu>
						</f:facet>
					</h:column>
					<h:column>
						<f:facet name="header">
							<h:outputText value="#{facesContext.translate('label.statistic.summary')}" />
						</f:facet>
						<ship:outputTextToggler value="#{r.summary}" title="#{r.summary}">
							<h:outputText value="#{r.description}" />
						</ship:outputTextToggler>
						<f:facet name="footer">
							<p:commandButton id="btn_addref" action="#{statisticController.addFunctionReference('edit')}" icon="fa fa-plus" look="primary" value="" title="#{facesContext.translate('button.add')}"
								style="height: 36px" ajax="true" update="form" styleClass="iconbutton" />
						</f:facet>
					</h:column>
					<h:column>
						<ship:removeButton action="#{statisticController.doRemoveFunctionReference(r.functionId, 'edit')}" value="" tooltip="#{facesContext.translate('button.remove')}" isLink="true"
							title="#{facesContext.translate('title.delete.approve')}" approveButtonLabel="#{facesContext.translate('button.yes')}" cancelButtonLabel="#{facesContext.translate('button.no')}">
							<h:outputText value="#{facesContext.translate('confirmation.delete', r.name)}" />
						</ship:removeButton>
					</h:column>
				</h:dataTable>
				<h:outputText value="#{facesContext.translate('label.statistic.creator')}" rendered="#{profile.hasPrivilege('statisticadmin')}" />
				<h:panelGrid columns="2" rendered="#{profile.hasPrivilege('statisticadmin')}">
					<p:selectOneMenu id="creator" value="#{statisticModel.functionBean.creator.usnr}" styleClass="select2dropdown"
						onchange="ship.doShow('approveCreatorOf#{statisticModel.functionBean.functionId}')">
						<f:selectItems value="#{statisticModel.allSquareUsers}" var="us" itemValue="#{us.usnr}" itemLabel="#{us.fullname}" />
					</p:selectOneMenu>
					<ui:fragment>
						<div id="approveCreatorOf#{statisticModel.functionBean.functionId}" style="display: none;">
							<p:commandButton id="btn_creator" action="#{statisticController.doSwitchCreator}" immediate="true" ajax="false" value="#{facesContext.translate('button.approve')}" styleClass="attention" />
						</div>
					</ui:fragment>
				</h:panelGrid>
				<h:outputText value="" />
			</p:panelGrid>
		</ui:define>
		<ui:define name="formbuttons">
			<p:commandButton id="btn_update" action="#{statisticController.doUpdateFunction}" value="#{facesContext.translate('button.approve')}" ajax="false" />
			<p:commandButton id="btn_updateandactivate" action="#{statisticController.doUpdateAndActivateFunction}" value="#{facesContext.translate('button.approveandactivate')}" ajax="false"
				rendered="#{profile.hasPrivilege('statisticadmin')}" />
			<p:commandButton id="btn_cancel" action="#{statisticController.toWelcome}" value="#{facesContext.translate('button.cancel')}" immediate="true" ajax="false" />
		</ui:define>
	</ui:composition>
</h:body>
</html>